/**
 * Upbit Open API
 * ## REST API for Upbit Exchange - Base URL: [https://api.upbit.com] - Official Upbit API Documents: [https://docs.upbit.com] - Official Support email: [open-api@upbit.com] 
 *
 * OpenAPI spec version: 1.0.0
 * Contact: ujhin942@gmail.com
 *
 * NOTE: This class is auto generated by the swagger code generator 2.4.18.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */



#include "Account.h"

namespace io {
namespace swagger {
namespace client {
namespace model {

Account::Account()
{
    m_Currency = utility::conversions::to_string_t("");
    m_CurrencyIsSet = false;
    m_Balance = utility::conversions::to_string_t("");
    m_BalanceIsSet = false;
    m_Locked = utility::conversions::to_string_t("");
    m_LockedIsSet = false;
    m_Avg_buy_price = utility::conversions::to_string_t("");
    m_Avg_buy_priceIsSet = false;
    m_Avg_buy_price_modified = false;
    m_Avg_buy_price_modifiedIsSet = false;
    m_Unit_currency = utility::conversions::to_string_t("");
    m_Unit_currencyIsSet = false;
}

Account::~Account()
{
}

void Account::validate()
{
    // TODO: implement validation
}

web::json::value Account::toJson() const
{
    web::json::value val = web::json::value::object();

    if(m_CurrencyIsSet)
    {
        val[utility::conversions::to_string_t("currency")] = ModelBase::toJson(m_Currency);
    }
    if(m_BalanceIsSet)
    {
        val[utility::conversions::to_string_t("balance")] = ModelBase::toJson(m_Balance);
    }
    if(m_LockedIsSet)
    {
        val[utility::conversions::to_string_t("locked")] = ModelBase::toJson(m_Locked);
    }
    if(m_Avg_buy_priceIsSet)
    {
        val[utility::conversions::to_string_t("avg_buy_price")] = ModelBase::toJson(m_Avg_buy_price);
    }
    if(m_Avg_buy_price_modifiedIsSet)
    {
        val[utility::conversions::to_string_t("avg_buy_price_modified")] = ModelBase::toJson(m_Avg_buy_price_modified);
    }
    if(m_Unit_currencyIsSet)
    {
        val[utility::conversions::to_string_t("unit_currency")] = ModelBase::toJson(m_Unit_currency);
    }

    return val;
}

void Account::fromJson(web::json::value& val)
{
    if(val.has_field(utility::conversions::to_string_t("currency")))
    {
        web::json::value& fieldValue = val[utility::conversions::to_string_t("currency")];
        if(!fieldValue.is_null())
        {
            setCurrency(ModelBase::stringFromJson(fieldValue));
        }
    }
    if(val.has_field(utility::conversions::to_string_t("balance")))
    {
        web::json::value& fieldValue = val[utility::conversions::to_string_t("balance")];
        if(!fieldValue.is_null())
        {
            setBalance(ModelBase::stringFromJson(fieldValue));
        }
    }
    if(val.has_field(utility::conversions::to_string_t("locked")))
    {
        web::json::value& fieldValue = val[utility::conversions::to_string_t("locked")];
        if(!fieldValue.is_null())
        {
            setLocked(ModelBase::stringFromJson(fieldValue));
        }
    }
    if(val.has_field(utility::conversions::to_string_t("avg_buy_price")))
    {
        web::json::value& fieldValue = val[utility::conversions::to_string_t("avg_buy_price")];
        if(!fieldValue.is_null())
        {
            setAvgBuyPrice(ModelBase::stringFromJson(fieldValue));
        }
    }
    if(val.has_field(utility::conversions::to_string_t("avg_buy_price_modified")))
    {
        web::json::value& fieldValue = val[utility::conversions::to_string_t("avg_buy_price_modified")];
        if(!fieldValue.is_null())
        {
            setAvgBuyPriceModified(ModelBase::boolFromJson(fieldValue));
        }
    }
    if(val.has_field(utility::conversions::to_string_t("unit_currency")))
    {
        web::json::value& fieldValue = val[utility::conversions::to_string_t("unit_currency")];
        if(!fieldValue.is_null())
        {
            setUnitCurrency(ModelBase::stringFromJson(fieldValue));
        }
    }
}

void Account::toMultipart(std::shared_ptr<MultipartFormData> multipart, const utility::string_t& prefix) const
{
    utility::string_t namePrefix = prefix;
    if(namePrefix.size() > 0 && namePrefix.substr(namePrefix.size() - 1) != utility::conversions::to_string_t("."))
    {
        namePrefix += utility::conversions::to_string_t(".");
    }

    if(m_CurrencyIsSet)
    {
        multipart->add(ModelBase::toHttpContent(namePrefix + utility::conversions::to_string_t("currency"), m_Currency));
        
    }
    if(m_BalanceIsSet)
    {
        multipart->add(ModelBase::toHttpContent(namePrefix + utility::conversions::to_string_t("balance"), m_Balance));
        
    }
    if(m_LockedIsSet)
    {
        multipart->add(ModelBase::toHttpContent(namePrefix + utility::conversions::to_string_t("locked"), m_Locked));
        
    }
    if(m_Avg_buy_priceIsSet)
    {
        multipart->add(ModelBase::toHttpContent(namePrefix + utility::conversions::to_string_t("avg_buy_price"), m_Avg_buy_price));
        
    }
    if(m_Avg_buy_price_modifiedIsSet)
    {
        multipart->add(ModelBase::toHttpContent(namePrefix + utility::conversions::to_string_t("avg_buy_price_modified"), m_Avg_buy_price_modified));
    }
    if(m_Unit_currencyIsSet)
    {
        multipart->add(ModelBase::toHttpContent(namePrefix + utility::conversions::to_string_t("unit_currency"), m_Unit_currency));
        
    }
}

void Account::fromMultiPart(std::shared_ptr<MultipartFormData> multipart, const utility::string_t& prefix)
{
    utility::string_t namePrefix = prefix;
    if(namePrefix.size() > 0 && namePrefix.substr(namePrefix.size() - 1) != utility::conversions::to_string_t("."))
    {
        namePrefix += utility::conversions::to_string_t(".");
    }

    if(multipart->hasContent(utility::conversions::to_string_t("currency")))
    {
        setCurrency(ModelBase::stringFromHttpContent(multipart->getContent(utility::conversions::to_string_t("currency"))));
    }
    if(multipart->hasContent(utility::conversions::to_string_t("balance")))
    {
        setBalance(ModelBase::stringFromHttpContent(multipart->getContent(utility::conversions::to_string_t("balance"))));
    }
    if(multipart->hasContent(utility::conversions::to_string_t("locked")))
    {
        setLocked(ModelBase::stringFromHttpContent(multipart->getContent(utility::conversions::to_string_t("locked"))));
    }
    if(multipart->hasContent(utility::conversions::to_string_t("avg_buy_price")))
    {
        setAvgBuyPrice(ModelBase::stringFromHttpContent(multipart->getContent(utility::conversions::to_string_t("avg_buy_price"))));
    }
    if(multipart->hasContent(utility::conversions::to_string_t("avg_buy_price_modified")))
    {
        setAvgBuyPriceModified(ModelBase::boolFromHttpContent(multipart->getContent(utility::conversions::to_string_t("avg_buy_price_modified"))));
    }
    if(multipart->hasContent(utility::conversions::to_string_t("unit_currency")))
    {
        setUnitCurrency(ModelBase::stringFromHttpContent(multipart->getContent(utility::conversions::to_string_t("unit_currency"))));
    }
}

utility::string_t Account::getCurrency() const
{
    return m_Currency;
}


void Account::setCurrency(utility::string_t value)
{
    m_Currency = value;
    m_CurrencyIsSet = true;
}
bool Account::currencyIsSet() const
{
    return m_CurrencyIsSet;
}

void Account::unsetCurrency()
{
    m_CurrencyIsSet = false;
}

utility::string_t Account::getBalance() const
{
    return m_Balance;
}


void Account::setBalance(utility::string_t value)
{
    m_Balance = value;
    m_BalanceIsSet = true;
}
bool Account::balanceIsSet() const
{
    return m_BalanceIsSet;
}

void Account::unsetBalance()
{
    m_BalanceIsSet = false;
}

utility::string_t Account::getLocked() const
{
    return m_Locked;
}


void Account::setLocked(utility::string_t value)
{
    m_Locked = value;
    m_LockedIsSet = true;
}
bool Account::lockedIsSet() const
{
    return m_LockedIsSet;
}

void Account::unsetLocked()
{
    m_LockedIsSet = false;
}

utility::string_t Account::getAvgBuyPrice() const
{
    return m_Avg_buy_price;
}


void Account::setAvgBuyPrice(utility::string_t value)
{
    m_Avg_buy_price = value;
    m_Avg_buy_priceIsSet = true;
}
bool Account::avgBuyPriceIsSet() const
{
    return m_Avg_buy_priceIsSet;
}

void Account::unsetAvg_buy_price()
{
    m_Avg_buy_priceIsSet = false;
}

bool Account::isAvgBuyPriceModified() const
{
    return m_Avg_buy_price_modified;
}


void Account::setAvgBuyPriceModified(bool value)
{
    m_Avg_buy_price_modified = value;
    m_Avg_buy_price_modifiedIsSet = true;
}
bool Account::avgBuyPriceModifiedIsSet() const
{
    return m_Avg_buy_price_modifiedIsSet;
}

void Account::unsetAvg_buy_price_modified()
{
    m_Avg_buy_price_modifiedIsSet = false;
}

utility::string_t Account::getUnitCurrency() const
{
    return m_Unit_currency;
}


void Account::setUnitCurrency(utility::string_t value)
{
    m_Unit_currency = value;
    m_Unit_currencyIsSet = true;
}
bool Account::unitCurrencyIsSet() const
{
    return m_Unit_currencyIsSet;
}

void Account::unsetUnit_currency()
{
    m_Unit_currencyIsSet = false;
}

}
}
}
}

