# Upbit Open API
#
# ## REST API for Upbit Exchange - Base URL: [https://api.upbit.com] - Official Upbit API Documents: [https://docs.upbit.com] - Official Support email: [open-api@upbit.com] 
#
# OpenAPI spec version: 1.0.0
# Contact: ujhin942@gmail.com
# Generated by: https://github.com/swagger-api/swagger-codegen.git


#' BidAccount Class
#'
#' @field currency 
#' @field balance 
#' @field locked 
#' @field avg_buy_price 
#' @field avg_buy_price_modified 
#' @field unit_currency 
#'
#' @importFrom R6 R6Class
#' @importFrom jsonlite fromJSON toJSON
#' @export
BidAccount <- R6::R6Class(
  'BidAccount',
  public = list(
    `currency` = NULL,
    `balance` = NULL,
    `locked` = NULL,
    `avg_buy_price` = NULL,
    `avg_buy_price_modified` = NULL,
    `unit_currency` = NULL,
    initialize = function(`currency`, `balance`, `locked`, `avg_buy_price`, `avg_buy_price_modified`, `unit_currency`){
      if (!missing(`currency`)) {
        stopifnot(is.character(`currency`), length(`currency`) == 1)
        self$`currency` <- `currency`
      }
      if (!missing(`balance`)) {
        stopifnot(is.character(`balance`), length(`balance`) == 1)
        self$`balance` <- `balance`
      }
      if (!missing(`locked`)) {
        stopifnot(is.character(`locked`), length(`locked`) == 1)
        self$`locked` <- `locked`
      }
      if (!missing(`avg_buy_price`)) {
        stopifnot(is.character(`avg_buy_price`), length(`avg_buy_price`) == 1)
        self$`avg_buy_price` <- `avg_buy_price`
      }
      if (!missing(`avg_buy_price_modified`)) {
        self$`avg_buy_price_modified` <- `avg_buy_price_modified`
      }
      if (!missing(`unit_currency`)) {
        stopifnot(is.character(`unit_currency`), length(`unit_currency`) == 1)
        self$`unit_currency` <- `unit_currency`
      }
    },
    toJSON = function() {
      BidAccountObject <- list()
      if (!is.null(self$`currency`)) {
        BidAccountObject[['currency']] <- self$`currency`
      }
      if (!is.null(self$`balance`)) {
        BidAccountObject[['balance']] <- self$`balance`
      }
      if (!is.null(self$`locked`)) {
        BidAccountObject[['locked']] <- self$`locked`
      }
      if (!is.null(self$`avg_buy_price`)) {
        BidAccountObject[['avg_buy_price']] <- self$`avg_buy_price`
      }
      if (!is.null(self$`avg_buy_price_modified`)) {
        BidAccountObject[['avg_buy_price_modified']] <- self$`avg_buy_price_modified`
      }
      if (!is.null(self$`unit_currency`)) {
        BidAccountObject[['unit_currency']] <- self$`unit_currency`
      }

      BidAccountObject
    },
    fromJSON = function(BidAccountJson) {
      BidAccountObject <- jsonlite::fromJSON(BidAccountJson)
      if (!is.null(BidAccountObject$`currency`)) {
        self$`currency` <- BidAccountObject$`currency`
      }
      if (!is.null(BidAccountObject$`balance`)) {
        self$`balance` <- BidAccountObject$`balance`
      }
      if (!is.null(BidAccountObject$`locked`)) {
        self$`locked` <- BidAccountObject$`locked`
      }
      if (!is.null(BidAccountObject$`avg_buy_price`)) {
        self$`avg_buy_price` <- BidAccountObject$`avg_buy_price`
      }
      if (!is.null(BidAccountObject$`avg_buy_price_modified`)) {
        self$`avg_buy_price_modified` <- BidAccountObject$`avg_buy_price_modified`
      }
      if (!is.null(BidAccountObject$`unit_currency`)) {
        self$`unit_currency` <- BidAccountObject$`unit_currency`
      }
    },
    toJSONString = function() {
       sprintf(
        '{
           "currency": %s,
           "balance": %s,
           "locked": %s,
           "avg_buy_price": %s,
           "avg_buy_price_modified": %s,
           "unit_currency": %s
        }',
        self$`currency`,
        self$`balance`,
        self$`locked`,
        self$`avg_buy_price`,
        self$`avg_buy_price_modified`,
        self$`unit_currency`
      )
    },
    fromJSONString = function(BidAccountJson) {
      BidAccountObject <- jsonlite::fromJSON(BidAccountJson)
      self$`currency` <- BidAccountObject$`currency`
      self$`balance` <- BidAccountObject$`balance`
      self$`locked` <- BidAccountObject$`locked`
      self$`avg_buy_price` <- BidAccountObject$`avg_buy_price`
      self$`avg_buy_price_modified` <- BidAccountObject$`avg_buy_price_modified`
      self$`unit_currency` <- BidAccountObject$`unit_currency`
    }
  )
)
