# Upbit Open API
#
# ## REST API for Upbit Exchange - Base URL: [https://api.upbit.com] - Official Upbit API Documents: [https://docs.upbit.com] - Official Support email: [open-api@upbit.com] 
#
# OpenAPI spec version: 1.0.0
# Contact: ujhin942@gmail.com
# Generated by: https://github.com/swagger-api/swagger-codegen.git

#' @title Deposit operations
#' @description swagger.Deposit
#'
#' @field path Stores url path of the request.
#' @field apiClient Handles the client-server communication.
#' @field userAgent Set the user agent of the request.
#'
#' @importFrom R6 R6Class
#'
#' @section Methods:
#' \describe{
#'
#' deposit_coin_address 개별 입금 주소 조회
#'
#'
#' deposit_coin_addresses 전체 입금 주소 조회
#'
#'
#' deposit_generate_coin_address 입금 주소 생성 요청
#'
#'
#' deposit_info 개별 입금 조회
#'
#'
#' deposit_info_all 입금 리스트 조회
#'
#' }
#'
#' @export
DepositApi <- R6::R6Class(
  'DepositApi',
  public = list(
    userAgent = "Swagger-Codegen/1.0.0/r",
    apiClient = NULL,
    initialize = function(apiClient){
      if (!missing(apiClient)) {
        self$apiClient <- apiClient
      }
      else {
        self$apiClient <- ApiClient$new()
      }
    },
    deposit_coin_address = function(currency, ...){
      args <- list(...)
      queryParams <- list()
      headerParams <- character()

      if (!missing(`currency`)) {
        queryParams['currency'] <- currency
      }

      urlPath <- "/deposits/coin_address"
      resp <- self$apiClient$callApi(url = paste0(self$apiClient$basePath, urlPath),
                                 method = "GET",
                                 queryParams = queryParams,
                                 headerParams = headerParams,
                                 body = body,
                                 ...)
      
      if (httr::status_code(resp) >= 200 && httr::status_code(resp) <= 299) {
        returnObject <- DepositCompleteResponse$new()
        result <- returnObject$fromJSON(httr::content(resp, "text", encoding = "UTF-8"))
        Response$new(returnObject, resp)
      } else if (httr::status_code(resp) >= 400 && httr::status_code(resp) <= 499) {
        Response$new("API client error", resp)
      } else if (httr::status_code(resp) >= 500 && httr::status_code(resp) <= 599) {
        Response$new("API server error", resp)
      }

    },
    deposit_coin_addresses = function(...){
      args <- list(...)
      queryParams <- list()
      headerParams <- character()

      urlPath <- "/deposits/coin_addresses"
      resp <- self$apiClient$callApi(url = paste0(self$apiClient$basePath, urlPath),
                                 method = "GET",
                                 queryParams = queryParams,
                                 headerParams = headerParams,
                                 body = body,
                                 ...)
      
      if (httr::status_code(resp) >= 200 && httr::status_code(resp) <= 299) {
        returnObject <- TODO_OBJECT_MAPPING$new()
        result <- returnObject$fromJSON(httr::content(resp, "text", encoding = "UTF-8"))
        Response$new(returnObject, resp)
      } else if (httr::status_code(resp) >= 400 && httr::status_code(resp) <= 499) {
        Response$new("API client error", resp)
      } else if (httr::status_code(resp) >= 500 && httr::status_code(resp) <= 599) {
        Response$new("API server error", resp)
      }

    },
    deposit_generate_coin_address = function(currency, ...){
      args <- list(...)
      queryParams <- list()
      headerParams <- character()

      body <- list(
          "currency" = currency
      )

      urlPath <- "/deposits/generate_coin_address"
      resp <- self$apiClient$callApi(url = paste0(self$apiClient$basePath, urlPath),
                                 method = "POST",
                                 queryParams = queryParams,
                                 headerParams = headerParams,
                                 body = body,
                                 ...)
      
      if (httr::status_code(resp) >= 200 && httr::status_code(resp) <= 299) {
        returnObject <- DepositCompleteResponse$new()
        result <- returnObject$fromJSON(httr::content(resp, "text", encoding = "UTF-8"))
        Response$new(returnObject, resp)
      } else if (httr::status_code(resp) >= 400 && httr::status_code(resp) <= 499) {
        Response$new("API client error", resp)
      } else if (httr::status_code(resp) >= 500 && httr::status_code(resp) <= 599) {
        Response$new("API server error", resp)
      }

    },
    deposit_info = function(uuid, txid, currency, ...){
      args <- list(...)
      queryParams <- list()
      headerParams <- character()

      if (!missing(`uuid`)) {
        queryParams['uuid'] <- uuid
      }

      if (!missing(`txid`)) {
        queryParams['txid'] <- txid
      }

      if (!missing(`currency`)) {
        queryParams['currency'] <- currency
      }

      urlPath <- "/deposit"
      resp <- self$apiClient$callApi(url = paste0(self$apiClient$basePath, urlPath),
                                 method = "GET",
                                 queryParams = queryParams,
                                 headerParams = headerParams,
                                 body = body,
                                 ...)
      
      if (httr::status_code(resp) >= 200 && httr::status_code(resp) <= 299) {
        returnObject <- Deposit$new()
        result <- returnObject$fromJSON(httr::content(resp, "text", encoding = "UTF-8"))
        Response$new(returnObject, resp)
      } else if (httr::status_code(resp) >= 400 && httr::status_code(resp) <= 499) {
        Response$new("API client error", resp)
      } else if (httr::status_code(resp) >= 500 && httr::status_code(resp) <= 599) {
        Response$new("API server error", resp)
      }

    },
    deposit_info_all = function(currency, state, uuids, txids, limit, page, order_by, ...){
      args <- list(...)
      queryParams <- list()
      headerParams <- character()

      if (!missing(`currency`)) {
        queryParams['currency'] <- currency
      }

      if (!missing(`state`)) {
        queryParams['state'] <- state
      }

      if (!missing(`uuids`)) {
        queryParams['uuids'] <- uuids
      }

      if (!missing(`txids`)) {
        queryParams['txids'] <- txids
      }

      if (!missing(`limit`)) {
        queryParams['limit'] <- limit
      }

      if (!missing(`page`)) {
        queryParams['page'] <- page
      }

      if (!missing(`order_by`)) {
        queryParams['order_by'] <- order_by
      }

      urlPath <- "/deposits"
      resp <- self$apiClient$callApi(url = paste0(self$apiClient$basePath, urlPath),
                                 method = "GET",
                                 queryParams = queryParams,
                                 headerParams = headerParams,
                                 body = body,
                                 ...)
      
      if (httr::status_code(resp) >= 200 && httr::status_code(resp) <= 299) {
        returnObject <- Deposit$new()
        result <- returnObject$fromJSON(httr::content(resp, "text", encoding = "UTF-8"))
        Response$new(returnObject, resp)
      } else if (httr::status_code(resp) >= 400 && httr::status_code(resp) <= 499) {
        Response$new("API client error", resp)
      } else if (httr::status_code(resp) >= 500 && httr::status_code(resp) <= 599) {
        Response$new("API server error", resp)
      }

    }
  )
)
